clear
# load the full model of the robot
load fully_solved_dynamics.mat 
load jacobian.mat

#q_n = [0.8911320000000003, 0.7636480000000003, 1.3156599999999998, 1.4852200000000004]#[-1.27 0.98 0.25 0]#[0 0 2 0]#
q_n = [pi/5 pi/3 pi/3 pi/3];
t_max = [1 1 1 1];

# add the physical parameters
J_ = subs(J, {l0 l1 l2 l3 l4 r1 r2 r3 r4 m1 m2 m3 m4},{ 0.05 0.5 0.5 0.5 0.7 0.25 0.25 0.25 0.25 0.5 0.5 0.5 0.5});
G_ = subs(G, {l0 l1 l2 l3 l4 r1 r2 r3 r4 m1 m2 m3 m4 g },{ 0.05 0.5 0.5 0.5 0.7 0.25 0.25 0.25 0.25 0.5 0.5 0.5 0.5 9.81});
# add the actual joint positions
G_n = eval(subs(G_, {q1 q2 q3 q4},q_n))
J_n = eval(subs(J_, {q1 q2 q3 q4},q_n));
J_n = J_n(5:6,:)
J_nT = J_n';

# pseudo-inverse
J_n_invT = pinv(J_nT); #inv(J_nT'*J_nT)*J_nT';

f_lim_xy = [];
for i = 0:15
  t_ = t_max;
  # calculation of all the possible upper and lower boundary combinations
  if ~mod(i,2)
    t_(1) = -t_(1);
  end
  if ~mod(fix(i/2),2)
    t_(2) = -t_(2);
  end
  if ~mod(fix(i/4),2)
    t_(3) = -t_(3);
  end
  if ~mod(fix(i/8),2)
    t_(4) = -t_(4);
  end
  # calculate force for each limit using pseudo inverse
  f_lim_xy = [f_lim_xy J_n_invT*(t_')];
end

f_map_out = [];
f_map_in = [];
color_map = [];
for fx = -10:0.1:10
  for fy = -10:0.1:10
    # motor torque calculation
    t = J_n'*[fx; fy];
    
    # find if possible to achieve
    if any(abs(t(:)) > t_max(:))
      f_map_out = [f_map_out [fx; fy]];
    else
      f_map_in = [f_map_in [fx; fy]];
    end
  end
end

figure(1)
plot(f_map_out(1,:),f_map_out(2,:),'ro');
hold on;
plot(f_map_in(1,:),f_map_in(2,:),'go');
# plot forces generated by limit torques
plot(f_lim_xy(1,:),f_lim_xy(2,:),'bs','LineWidth',2);

